Attribute VB_Name = "Highlight"
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
'
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

Option Explicit

Private Type rgbColors
    Red As Long
    Green As Long
    Blue As Long
End Type

Private Type Keywords
    ColorId As Long
    Keyword As String
End Type

Private KeyWordlist() As Keywords
Private rtfColorTable() As rgbColors
Private myRtfColorTable As String


Public Sub InitKeywords()
    Dim i As Long

    ' Farben festlegen in Rot / Grn / Vlau Anteilen (rgb)
    ' (0 ist fr die Vordergrundfarbe reserviert)
    ReDim rtfColorTable(2) ' Anzahl der Farben festlegen
    
    'id: 0
    rtfColorTable(0).Red = 0
    rtfColorTable(0).Green = 0
    rtfColorTable(0).Blue = 0
    
    'id: 1 enspricht blau
    rtfColorTable(1).Red = 0
    rtfColorTable(1).Green = 0
    rtfColorTable(1).Blue = 255
    
    'id: 2 entspricht rot
    rtfColorTable(2).Red = 255
    rtfColorTable(2).Green = 0
    rtfColorTable(2).Blue = 0


    
    ' Keyworter die gehighlighted werden sollen definieren
    ReDim KeyWordlist(4) ' Anzahl der Keywrter festlegen
    KeyWordlist(1).Keyword = "If"     ' Wort zuweisen
    KeyWordlist(1).ColorId = 1        ' FarbID -> hier Blau
    KeyWordlist(2).Keyword = "Then"
    KeyWordlist(2).ColorId = 1
    KeyWordlist(3).Keyword = "Else"
    KeyWordlist(3).ColorId = 2        ' FarbID -> hier Rot
    KeyWordlist(4).Keyword = "End"
    KeyWordlist(4).ColorId = 2

    
    Call initRtfColorTable
End Sub



Private Sub initRtfColorTable()
    Dim i As Long
    myRtfColorTable = ""
    For i = 0 To UBound(rtfColorTable)
        With rtfColorTable(i)
        myRtfColorTable = myRtfColorTable & _
                            "\red" & .Red & _
                            "\green" & .Green & _
                            "\blue" & .Blue & ";"
        End With
    Next
End Sub


Public Sub highlightRTBox(ByVal RTB As RichTextBox, _
                            ByVal font As String, _
                            ByVal fontsize As Long, _
                            Optional vbCmp As VbCompareMethod = vbBinaryCompare)
    
    Dim header, colorTable, rtfStart, rtfEnd, rtCrLf As String
    Dim Text, standardFont As String
    Dim i, ii As Long
    
    'RTB.font = font
    RTB.SelFontName = font
    RTB.SelFontSize = fontsize
    fontsize = fontsize * 2
    
    header = "{\rtf1\ansi\deff0\deftab720{\fonttbl{\f0\fswiss MS Sans Serif;}" & _
             "{\f1\froman\fcharset2 Symbol;}{\f2\fmodern " & font & ";}}" & vbCrLf
    colorTable = "{\colortbl" & myRtfColorTable & "}" & vbCrLf
    rtfStart = "\deflang1031\pard"
    rtfEnd = "}"
    rtCrLf = "\par "
    standardFont = "\plain\f2\fs" & fontsize & " "
         
    Text = RTB.Text
    
    If Len(Text) <= 0 Then Exit Sub
    
    'Colorize
    For i = LBound(KeyWordlist) To UBound(KeyWordlist)
        With KeyWordlist(i)
            If .Keyword <> "" Then
                Text = Replace(Text, .Keyword, standardFont & "\cf" & _
                                 .ColorId & " " & .Keyword & standardFont _
                                 , , , vbCmp)
            End If
        End With
    Next
    Text = Replace(Text, vbCrLf, rtCrLf, , , vbBinaryCompare)
    
    RTB.TextRTF = header & colorTable & rtfStart & standardFont & Text & rtfEnd
End Sub
